//---------------------------------------------------------------------------
#include "QtSql.h"
//#include "libpq-fe.h"
#include <unistd.h>
#include <pwd.h>
//#include <libpq-fe.h>
#include "libpq-fe.h"
#warning is QtSql.cpp

//#define SPARC
//#define FROM_SO

#ifdef FROM_SO
const QString libpgso="libpq.so";
#warning ===========FROM_SO========
#endif

#ifdef SPARC
#include "unConsts.h"
#warning ===========Sparc==========
#endif
void QSqlError::settextError(QString err){str_error=err;}
QString QSqlError::text(){return(str_error);}
//*****************************QSqlDatabase*************************************
QSqlDatabase::QSqlDatabase(){/*PGconn *con*/exists_c=false;};
//-----------------------------------------
void QSqlDatabase::setDatabaseName(const QString & db_Name){dbName=db_Name;};
void QSqlDatabase::setUserName(const QString & user_Name){userName=user_Name;} ;
void QSqlDatabase::setHostName(const QString & host_Name){hostName=host_Name;} ;
void QSqlDatabase::setPassword(const QString & pass_Name){passName=pass_Name;} ;
void QSqlDatabase::setPort(const QString &port_Name){portName=port_Name;};
PGconn * QSqlDatabase::getcon(){return this->con;}
bool QSqlDatabase::isValid(){if(!con)return(false);qDebug()<<"PQstatus(con) "<<PQstatus(con);if(PQstatus(con) == CONNECTION_OK)return(true);else return(false);};
bool QSqlDatabase::open()
{
bool result=true;
try{
exists_c=false;
QString conninfo("host='%1' user='%2' password='%3' dbname='%4' port=%5");
conninfo=conninfo.arg(hostName).arg(userName).arg(passName).arg(dbName).arg(portName);
//----------------------->----->
#ifdef FROM_SO
typedef PGconn* (*MyPrototype)(const char *);
MyPrototype myFunction=(MyPrototype)QLibrary::resolve(libpgso,"PQconnectdb");
qDebug()<<"_-=PQconnectdb=-_ 0";
if(myFunction)con=myFunction(conninfo.toAscii().data());
qDebug()<<"_-=PQconnectdb=-_ 1";
#else
con = PQconnectdb(conninfo.toAscii().data());
#endif
//------------------------>---->
#ifdef FROM_SO
typedef int (*MyPrototype00)(PGconn*);
MyPrototype00 myFunction00=(MyPrototype00)QLibrary::resolve(libpgso,"PQstatus");
qDebug()<<"_-=PQstatus=-_ 0"; int abc;
if(myFunction)abc=myFunction00(con);
qDebug()<<"_-=PQstatus=-_ 1";
if(abc==CONNECTION_BAD){
qDebug()<<conninfo+"No connect";
typedef char* (*MyPrototype0)(PGconn*);
MyPrototype0 myFunction0=(MyPrototype0)QLibrary::resolve(libpgso,"PQerrorMessage");
qDebug()<<"_-=PQerrorMessage=-_ 0"; char *PQerrorMessage_char="";
if(myFunction0)PQerrorMessage_char=myFunction0(con);
qDebug()<<"_-=PQerrorMessage=-_ 1";
sqlError.str_error=PQerrorMessage_char;
result=false;
typedef void (*MyPrototype1)(PGconn*);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQfinish");
qDebug()<<"_-=PQfinish=-_ 0";
if(myFunction1)myFunction1(con);
qDebug()<<"_-=PQfinish=-_ 1";
return(result);
              }else result=true;
#else
if (PQstatus(con) == CONNECTION_BAD)
              {
qDebug()<<conninfo+"No connect";
sqlError.str_error=PQerrorMessage(con);
result=false;
PQfinish(con);
return(result);
              }else result=true;
#endif

qDebug()<<conninfo+ " OK";
exists_c=true;
}
catch(...){
qDebug()<<"ERROR :open()";
result=false;}

return(result);
}
QSqlError QSqlDatabase::lastError(){return(sqlError);}
//-->
void QSqlDatabase::close(){
#ifdef FROM_SO
typedef void (*MyPrototype1)(PGconn*);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQfinish");
qDebug()<<"_-=PQfinish=-_ 0";
if(myFunction1)myFunction1(con);
qDebug()<<"_-=PQfinish=-_ 1";
#else
qDebug()<<"close con "<<con;
qDebug()<<"status "<<PQstatus(con);
if(CONNECTION_BAD!=PQstatus(con))PQfinish(con);
qDebug()<<"---";
#endif
exists_c=false;qDebug()<<dbName+ " close";
                          }
QSqlDatabase::~QSqlDatabase(){
#ifdef FROM_SO
if(exists_c)
{
typedef void (*MyPrototype1)(PGconn*);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQfinish");
qDebug()<<"_-=PQfinish=-_ 0";
if(myFunction1)myFunction1(con);
qDebug()<<"_-=PQfinish=-_ 1";
}
#else
if(exists_c)PQfinish(con);
#endif
                             }
//******************************QSqlQuery***************************************
QSqlQuery::QSqlQuery(QSqlDatabase *coon)
{

//con=coon.con;
///////////////con=coon->con;
conP=coon;
irec=-1;
qDebug()<<coon->dbName<<"="<<coon->userName<<"="<<coon->hostName<<"="<<coon->passName<<"=";
//qDebug()<<coon.dbName<<"="<<coon.userName<<"="<<coon.hostName<<"="<<coon.passName<<"=";
}
bool QSqlQuery::seek(int z){
qDebug()<<"QSqlQuery::seek 0";
irec=z;return(true);/*need correct*/
qDebug()<<"QSqlQuery::seek 1";
                           }
//-
bool QSqlQuery::next()
{
qDebug()<<"QSqlQuery::next() 0";
bool result=false;
irec++;
if(irec<nrecords)result=true;else result=false;
qDebug()<<"QSqlQuery::next() 1";
return(result);
}
QVariant QSqlQuery::value(int j)
{
qDebug()<<"QSqlQuery::value 0";
char *res="***";
try
{
#ifdef FROM_SO
if((irec>-1)&&(irec<nrecords)&&(j>-1)&&(j<nfields)){
typedef char* (*MyPrototype1)(PGresult*,int,int);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQgetvalue");
qDebug()<<"_-=PQgetvalue=-_ 0";
if(myFunction1)res=myFunction1(res_sql,irec,j);
qDebug()<<"_-=PQgetvalue=-_ 1";                    }else res="error";
#else
if((irec>-1)&&(irec<nrecords)&&(j>-1)&&(j<nfields))res=PQgetvalue(res_sql,irec, j);else res="error";
#endif

}catch(...)
{
qDebug()<<"ERROR :QSqlQuery::value";
res="error";
};
QVariant result(res);
//qDebug()<<"QSqlQuery::value(int "+QString::number(j)+") "+QString(result.toString()).mid(0,200);
#ifdef SPARC
QString st0=fields.at(j);
if(st0==F_ATTR_ADD_DATE||st0==F_ATTR_DATA_POLUCH||
st0==F_ATTR_DATA_PRIN||st0==F_ATTR_IN_DATE||
st0==F_ATTR_OUT_DATE||st0==F_DELO_OFF_DATE||
st0==F_DELO_ON_DATE||st0==F_JURSD_DATA_RAZMNOZ||
st0==F_JURSD_DATA_VOZVRATA||st0==F_LOG_DATE||
st0==F_REP_DATE||st0==F_SOGL_DATE_S||st0=="FNAME"||st0=="FNAME1")
{
if(result.toInt()!=0){
QDateTime dt=QDateTime::fromTime_t(result.toInt());
result=QVariant(dt.toString("yyyy-MM-dd hh:mm:ss"));
                     }else result=QVariant("");
}
#endif
qDebug()<<"QSqlQuery::value 1";
return(result);
}

void QSqlQuery::recordfill()
{
qDebug()<<"QSqlQuery::recordfill 0";

fields.clear();
for(int i=0;i<nfields;i++){
try{
#ifdef FROM_SO
typedef char* (*MyPrototype1)(PGresult*,int);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQfname");
qDebug()<<"_-=PQfname=-_ 0";char *PQfname_char="";
if(myFunction1)PQfname_char=myFunction1(res_sql,i);else PQfname_char="UNKNOWN";
qDebug()<<"_-=PQfname=-_ 1";
fields.append(QString(PQfname_char).toUpper());
#else
fields.append(QString(PQfname(res_sql,i)).toUpper());
//qDebug()<<"QSqlQuery::record "+QString::number(i)+" "+QString(PQfname(res_sql,i));
#endif

   }catch(...){
fields.append("UNKNOWN");
qDebug()<<"ERROR: QSqlQuery::recordfill";
              }
                          }
qDebug()<<"QSqlQuery::recordfill 1";
}

QStringList QSqlQuery::record()
{
qDebug()<<"QSqlQuery::record() 0";
return(fields);
qDebug()<<"QSqlQuery::record() 1";
}
//-->
bool QSqlQuery::exec(QString strsql)
{
 qDebug()<<"QSqlQuery::exec 00";
bool result=true;
//qDebug()<<"QSqlQuery::exec(QString strsql)= |>"+QString(strsql.toAscii().data())+"<|\n";
#ifdef FROM_SO
typedef PGresult* (*MyPrototype1)(PGconn*,char*);
MyPrototype1 myFunction1=(MyPrototype1)QLibrary::resolve(libpgso,"PQexec");
qDebug()<<"_-=PQexec=-_ 0";
if(myFunction1)res_sql=myFunction1(conP->getcon()/*con*/,strsql.toAscii().data());
qDebug()<<"_-=PQexec=-_ 1";
#else
qDebug()<<conP->getcon();
res_sql=0;
qDebug()<<PQstatus(conP->getcon());
if(CONNECTION_BAD!=PQstatus(conP->getcon()))res_sql=PQexec(conP->getcon(),strsql.toAscii().data());
qDebug()<<res_sql;
#endif

 if(PQresultStatus(res_sql)==PGRES_COMMAND_OK){qDebug()<<"PGRES_COMMAND_OK";};
 if(PQresultStatus(res_sql)==PGRES_TUPLES_OK){qDebug()<<"PGRES_TUPLES_OK";};
         
#ifdef FROM_SO
typedef int (*MyPrototype2)(PGresult*);
MyPrototype2 myFunction2=(MyPrototype2)QLibrary::resolve(libpgso,"PQntuples");
qDebug()<<"_-=PQntuples=-_ 0";
if(myFunction2)nrecords=myFunction2(res_sql);else nrecords=0;qDebug()<<nrecords;
qDebug()<<"_-=PQntuples=-_ 1";
typedef int (*MyPrototype3)(PGresult*);
MyPrototype3 myFunction3=(MyPrototype3)QLibrary::resolve(libpgso,"PQnfields");
qDebug()<<"_-=PQnfields=-_ 0";
if(myFunction3)nfields=myFunction3(res_sql);else nfields=0;qDebug()<<nfields;
qDebug()<<"_-=PQnfields=-_ 1";
#else
	nrecords=PQntuples(res_sql);
	nfields=PQnfields(res_sql);
#endif

	if (nrecords == 0){
#ifdef FROM_SO
typedef char* (*MyPrototype4)(PGconn*);
MyPrototype4 myFunction4=(MyPrototype4)QLibrary::resolve(libpgso,"PQerrorMessage");
qDebug()<<"_-=PQerrorMessage=-_ 0";char * PQerrorMessage_char;
if(myFunction4)PQerrorMessage_char=myFunction4(con);else PQerrorMessage_char="error load *.os";
qDebug()<<"_-=PQerrorMessage=-_ 1";
QString error=QString(PQerrorMessage_char);
#else
QString error = QString(PQerrorMessage(conP->getcon()));
#endif
	    if (strlen(error.toAscii().data())==0) {
		//nfields=PQnfields(res_sql);
	        result=true;
	                                            } else {

sqlError.str_error=QString(/*PQerrorMessage(con)*/error);
PQclear(res_sql);
qDebug()<<"QSqlQuery::exec(QString strsql) ERROR: =>"+sqlError.str_error+"<=\n";
               result=false;
	                                                    }
                         } else {
	    //nfields=PQnfields(res_sql);
	    result=true;

	                          }
 exists_q=result;
 if(result)recordfill();
//---------
//--------
 qDebug()<<"QSqlQuery::exec 1";
 return(result);
}
//-->
QSqlError QSqlQuery::lastError(){
qDebug()<<"QSqlQuery::lastError() 0";
qDebug()<<sqlError.str_error;
qDebug()<<"QSqlQuery::lastError() 1";
return(sqlError);
                                }
//-->
bool QSqlQuery::isSelect(){
qDebug()<<"QSqlQuery::isSelect() 0";
bool res=false;if(nrecords>0)res=true;return(res);
qDebug()<<"QSqlQuery::isSelect() 1";
                          }
void QSqlQuery::close(){
qDebug()<<"QSqlQuery::close() 0";
PQclear(res_sql);
exists_q=false;
qDebug()<<"QSqlQuery::close() 1";
                       };
void QSqlQuery::clear(){
qDebug()<<"QSqlQuery::clear() 0";
if(exists_q)PQclear(res_sql);
exists_q=false;
qDebug()<<"QSqlQuery::clear() 1";
                       }
QSqlQuery::~QSqlQuery(){
qDebug()<<"QSqlQuery::~QSqlQuery() 0";
try{
if(exists_q)PQclear(res_sql);//    
   }catch(...){
qDebug()<<"Error: ~QSqlQuery()";
           };
qDebug()<<"QSqlQuery::~QSqlQuery() 1";
                       };
//-->
//--------------------------------











//---------------------------------------------------------------------------


