//---------------------------------------------------------------------------

#ifndef QtSqlH
#define QtSqlH
//---------------------------------------------------------------------------
#include <QString>
#include <QStringList>
#include <QtCore>


#include "libpq-fe.h"
class QSqlError
{
public:
QString str_error;
QString text();
void settextError(QString err);
};

class QSqlDatabase
 {
 public:
 QString dbName;
 QString userName;
 QString hostName;
 QString passName;
 QString portName;
 PGconn *con;
 QSqlError sqlError;
 QSqlDatabase();
 void setDatabaseName(const QString &db_Name);
 void setUserName(const QString &user_Name);
 void setHostName(const QString &host_Name);
 void setPassword(const QString &pass_Name);
 void setPort(const QString &port_Name);
 void close();
 bool open();
 bool isValid();
 QSqlError lastError();
 ~QSqlDatabase();
 PGconn *getcon();
 protected:
 bool exists_c;
 } ;

 class QSqlQuery
 {
 public:
 int nrecords;
 int nfields;
 int irec;
 //PGconn *con;
 QSqlDatabase *conP;
 PGresult  *res_sql;
 QStringList fields;
 QSqlError sqlError;
 QSqlQuery(QSqlDatabase *coon);
 bool exec(QString strsql);
 QSqlError lastError();
 bool isSelect();
 void clear();
 bool seek(int z);
 //-
 bool next();
 QVariant value(int i);
 void recordfill();
 QStringList record();
 void close();
 ~QSqlQuery();
 protected:
 bool exists_q;
 };


#endif
