//---------------------------------------------------------------------------
#include <QMainWindow>
#include <QMessageBox>
#include <QFileDialog>
#include "unDM.h"
#include "Unit2.h"

//---------------------------------------------------------------------------

TSelectForm ::TSelectForm(QWidget * parent):QMainWindow( parent){DataModule1=NULL;};
void TSelectForm ::SetUp2()
{
this->setupUi(this);
QObject::connect(pushButton_connect,SIGNAL(clicked()),this,SLOT(pushButton_connect_slot()));
QObject::connect(pushButton_select,SIGNAL(clicked()),this,SLOT(pushButton_select_slot()));

QObject::connect(pushButton_fill,SIGNAL(clicked()),this,SLOT(pushButton_fill_slot()));

QObject::connect(pushButton_clear,SIGNAL(clicked()),this,SLOT(pushButton_clear_slot()));

QObject::connect(pushButton_save,SIGNAL(clicked()),this,SLOT(pushButton_save_slot()));



//QObject::connect(Button2,SIGNAL(clicked()),this,SLOT(reject()));
}

void TSelectForm ::pushButton_connect_slot()
{


//DBConnected(QSqlDatabase *DBase,QString ConnName,QString DBName,QString UN,QString address,QString Pass,QString port) ;
if(NULL!=DataModule1)delete DataModule1;
DataModule1=new TDataModule();;
DataModule1->DBConnected(&(DataModule1->DOCFLOW),QString(""),lineEdit_bd->text(),lineEdit_user->text(),lineEdit_host->text(),lineEdit_passw->text(),lineEdit_port->text());



}


        void TSelectForm ::pushButton_select_slot()
        {
           treeWidget->clear();
          if(""==lineEdit_select->text().trimmed())return;
          QString SQLText=lineEdit_select->text().trimmed();
          QSqlQuery *TMPQuery = DataModule1->SelectFromDB(&(DataModule1->DOCFLOW), SQLText);
          qDebug()<<TMPQuery->record().count();
          QStringList stl;
          //for(int i=0;i<TMPQuery->record().count();i++)stl<<TMPQuery->record().fieldName(i);
          //treeWidget->setHeaderItem(new QTreeWidgetItem(stl));
          while(TMPQuery->next()){
          QStringList stl;
          for(int i=0;i<TMPQuery->record().count();i++)
          stl<<TMPQuery->value(i).toString().trimmed();

          treeWidget->addTopLevelItem(new QTreeWidgetItem(stl));

                                 }
          for(int i=0;i<TMPQuery->record().count();i++)
          treeWidget->resizeColumnToContents(i);



        }

        void TSelectForm ::pushButton_save_slot()
        {

        QByteArray  byt;byt.append(textEdit->toPlainText());


    QString SaveDialogFileName=QFileDialog::getSaveFileName (0, QString("  "),QString(QDateTime::currentDateTime().toString("ddMMyyyyhh_mm_zz")));
    if(SaveDialogFileName!=""){
    QFile file0(SaveDialogFileName);
    if (!file0.open(QIODevice::WriteOnly | QIODevice::Text)){
        QMessageBox msgBoxC;
        msgBoxC.setText("  \n"+SaveDialogFileName);
        msgBoxC.setDetailedText("");
        msgBoxC.exec();
    	return;                                              }
    file0.write(byt);
    file0.close();
                             }
        }
        void TSelectForm ::pushButton_clear_slot()
        {

         textEdit->clear();
        }
        void TSelectForm ::pushButton_fill_slot()
        {


         for(int i=0;i<treeWidget->topLevelItemCount();i++)
         {
          QString str=lineEdit_fill->text();
         for(int j=0;j<treeWidget->columnCount ();j++){
         QString sn="%"+QString::number(j);
         str.replace(sn,treeWidget->topLevelItem(i)->text(j));
                                                       }

         textEdit->textCursor().insertText('\n'+str);
                                                       
         }


        }
